Skip to content
geeksforgeeks
  • Courses
    • DSA to Development
    • Get IBM Certification
    • Newly Launched!
      • Master Django Framework
      • Become AWS Certified
    • For Working Professionals
      • Interview 101: DSA & System Design
      • Data Science Training Program
      • JAVA Backend Development (Live)
      • DevOps Engineering (LIVE)
      • Data Structures & Algorithms in Python
    • For Students
      • Placement Preparation Course
      • Data Science (Live)
      • Data Structure & Algorithm-Self Paced (C++/JAVA)
      • Master Competitive Programming (Live)
      • Full Stack Development with React & Node JS (Live)
    • Full Stack Development
    • Data Science Program
    • All Courses
  • Tutorials
    • Data Structures & Algorithms
    • ML & Data Science
    • Interview Corner
    • Programming Languages
    • Web Development
    • CS Subjects
    • DevOps And Linux
    • School Learning
  • Practice
    • Build your AI Agent
    • GfG 160
    • Problem of the Day
    • Practice Coding Problems
    • GfG SDE Sheet
  • Contests
    • Accenture Hackathon (Ending Soon!)
    • GfG Weekly [Rated Contest]
    • Job-A-Thon Hiring Challenge
    • All Contests and Events
  • DSA
  • Algorithms
  • Analysis of Algorithms
  • Sorting
  • Searching
  • Greedy
  • Recursion
  • Backtracking
  • Dynamic Programming
  • Divide and Conquer
  • Geometric Algorithms
  • Mathematical Algorithms
  • Pattern Searching
  • Bitwise Algorithms
  • Branch & Bound
  • Randomized Algorithms
Open In App
Next Article:
Prefix Sum Array - Implementation and Applications
Next article icon

Sliding Window Technique

Last Updated : 19 Feb, 2025
Comments
Improve
Suggest changes
Like Article
Like
Report

Sliding Window problems involve moving a fixed or variable-size window through a data structure, typically an array or string, to solve problems efficiently based on continuous subsets of elements. This technique is used when we need to find subarrays or substrings according to a given set of conditions.

Sliding-Window-Technique-copy-(1)

Sliding Window Technique

Table of Content

  • What is Sliding Window Technique?
  • How to use Sliding Window Technique?
  • How to Identify Sliding Window Problems
  • Use Cases of Sliding Window Technique
  • Practice Problems on Sliding Window Technique

What is Sliding Window Technique?

Sliding Window Technique is a method used to efficiently solve problems that involve defining a window or range in the input data (arrays or strings) and then moving that window across the data to perform some operation within the window. This technique is commonly used in algorithms like finding subarrays with a specific sum, finding the longest substring with unique characters, or solving problems that require a fixed-size window to process elements efficiently.

Let’s take an example to understand this properly, say we have an array of size N and also an integer K. Now, we have to calculate the maximum sum of a subarray having size exactly K. Now how should we approach this problem?

One way to do this by taking each subarray of size K from the array and find out the maximum sum of these subarrays. This can be done using Nested loops which will result into O(N2) Time Complexity.

But can we optimize this approach?

The answer is Yes, instead of taking each K sized subarray and calculating its sum, we can just take one K size subarray from 0 to K-1 index and calculate its sum now shift our range one by one along with the iterations and update the result, like in next iteration increase the left and right pointer and update the previous sum as shown in the below image:

sliding-window-1

Sliding Window Technique

Now follow this method for each iteration till we reach the end of the array:

sliding-window-technique-2

Sliding Window Technique

So, we can see that instead of recalculating the sum of each K sized subarray we are using previous window of size K and using its results we update the sum and shift the window right by moving left and right pointers, this operation is optimal because it take O(1) time to shift the range instead of recalculating.

This approach of shifting the pointers and calculating the results accordingly is known as Sliding window Technique.

 

How to use Sliding Window Technique?

There are basically two types of sliding window:

1. Fixed Size Sliding Window:

The general steps to solve these questions by following below steps:

  • Find the size of the window required, say K.
  • Compute the result for 1st window, i.e. include the first K elements of the data structure.
  • Then use a loop to slide the window by 1 and keep computing the result window by window.

2. Variable Size Sliding Window:

The general steps to solve these questions by following below steps:

  • In this type of sliding window problem, we increase our right pointer one by one till our condition is true.
  • At any step if our condition does not match, we shrink the size of our window by increasing left pointer.
  • Again, when our condition satisfies, we start increasing the right pointer and follow step 1.
  • We follow these steps until we reach to the end of the array.

How to Identify Sliding Window Problems:

  • These problems generally require Finding Maximum/Minimum Subarray, Substrings which satisfy some specific condition.
  • The size of the subarray or substring ‘K’ will be given in some of the problems.
  • These problems can easily be solved in O(N2) time complexity using nested loops, using sliding window we can solve these in O(n) Time Complexity.
  • Required Time Complexity: O(N) or O(Nlog(N))
  • Constraints: N <= 106 , If N is the size of the Array/String.

Use Cases of Sliding Window Technique:

1. To find the maximum sum of all subarrays of size K:

Given an array of integers of size ‘n’, Our aim is to calculate the maximum sum of ‘k’ consecutive elements in the array.

Input  : arr[] = {100, 200, 300, 400}, k = 2
Output : 700

Input  : arr[] = {1, 4, 2, 10, 23, 3, 1, 0, 20}, k = 4 
Output : 39
We get maximum sum by adding subarray {4, 2, 10, 23} of size 4.

Input  : arr[] = {2, 3}, k = 3
Output : Invalid
There is no subarray of size 3 as size of whole array is 2.

Naïve Approach: So, let’s analyze the problem with Brute Force Approach. We start with the first index and sum till the kth element. We do it for all possible consecutive blocks or groups of k elements. This method requires a nested for loop, the outer for loop starts with the starting element of the block of k elements, and the inner or the nested loop will add up till the kth element.

Below is the implementation of the above approach: 

C++
// O(n*k) solution for finding maximum sum of // a subarray of size k #include <bits/stdc++.h> using namespace std;  // Returns maximum sum in a subarray of size k. int maxSum(int arr[], int n, int k) {     // Initialize result     int max_sum = INT_MIN;      // Consider all blocks starting with i.     for (int i = 0; i < n - k + 1; i++) {         int current_sum = 0;         for (int j = 0; j < k; j++)             current_sum = current_sum + arr[i + j];          // Update result if required.         max_sum = max(current_sum, max_sum);     }      return max_sum; }  // Driver code int main() {     int arr[] = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };     int k = 4;     int n = sizeof(arr) / sizeof(arr[0]);     cout << maxSum(arr, n, k);     return 0; }  // This code is contributed by Aditya Kumar (adityakumar129) 
C
// O(n*k) solution for finding maximum sum of // a subarray of size k #include <limits.h> #include <math.h> #include <stdio.h>  // Find maximum between two numbers. int max(int num1, int num2) {     return (num1 > num2) ? num1 : num2; }  // Returns maximum sum in a subarray of size k. int maxSum(int arr[], int n, int k) {     // Initialize result     int max_sum = INT_MIN;      // Consider all blocks starting with i.     for (int i = 0; i < n - k + 1; i++) {         int current_sum = 0;         for (int j = 0; j < k; j++)             current_sum = current_sum + arr[i + j];          // Update result if required.         max_sum = max(current_sum, max_sum);     }      return max_sum; }  // Driver code int main() {     int arr[] = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };     int k = 4;     int n = sizeof(arr) / sizeof(arr[0]);     printf("%d", maxSum(arr, n, k));     return 0; }  // This code is contributed by Aditya Kumar (adityakumar129) 
Java
// Java code O(n*k) solution for finding maximum sum of // a subarray of size k class GFG {     // Returns maximum sum in     // a subarray of size k.     static int maxSum(int arr[], int n, int k)     {         // Initialize result         int max_sum = Integer.MIN_VALUE;          // Consider all blocks starting with i.         for (int i = 0; i < n - k + 1; i++) {             int current_sum = 0;             for (int j = 0; j < k; j++)                 current_sum = current_sum + arr[i + j];              // Update result if required.             max_sum = Math.max(current_sum, max_sum);         }          return max_sum;     }      // Driver code     public static void main(String[] args)     {         int arr[] = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };         int k = 4;         int n = arr.length;         System.out.println(maxSum(arr, n, k));     } }  // This code is contributed by Aditya Kumar (adityakumar129) 
Python
# code import sys  # O(n * k) solution for finding # maximum sum of a subarray of size k INT_MIN = -sys.maxsize - 1  # Returns maximum sum in a # subarray of size k.   def maxSum(arr, n, k):      # Initialize result     max_sum = INT_MIN      # Consider all blocks     # starting with i.     for i in range(n - k + 1):         current_sum = 0         for j in range(k):             current_sum = current_sum + arr[i + j]          # Update result if required.         max_sum = max(current_sum, max_sum)      return max_sum   # Driver code arr = [1, 4, 2, 10, 2,        3, 1, 0, 20] k = 4 n = len(arr) print(maxSum(arr, n, k))  # This code is contributed by mits 
C#
// C# code here O(n*k) solution for // finding maximum sum of a subarray // of size k using System;  class GFG {      // Returns maximum sum in a     // subarray of size k.     static int maxSum(int[] arr, int n, int k)     {         // Initialize result         int max_sum = int.MinValue;          // Consider all blocks starting         // with i.         for (int i = 0; i < n - k + 1; i++) {             int current_sum = 0;             for (int j = 0; j < k; j++)                 current_sum = current_sum + arr[i + j];              // Update result if required.             max_sum = Math.Max(current_sum, max_sum);         }          return max_sum;     }      // Driver code     public static void Main()     {         int[] arr = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };         int k = 4;         int n = arr.Length;         Console.WriteLine(maxSum(arr, n, k));     } }  // This code is contributed by anuj_67. 
JavaScript
// Function to find the maximum sum of a subarray of size k function maxSum(arr, n, k) {     // Initialize result     let max_sum = Number.MIN_SAFE_INTEGER;      // Consider all blocks starting with i     for (let i = 0; i < n - k + 1; i++) {         let current_sum = 0;         for (let j = 0; j < k; j++) {             current_sum += arr[i + j];         }          // Update result if required         max_sum = Math.max(current_sum, max_sum);     }      return max_sum; }  // Driver code const arr = [1, 4, 2, 10, 2, 3, 1, 0, 20]; const k = 4; const n = arr.length; console.log(maxSum(arr, n, k)); 
PHP
<?php     // code ?> <?php // O(n*k) solution for finding maximum sum of // a subarray of size k  // Returns maximum sum in a subarray of size k. function maxSum($arr, $n, $k) {          // Initialize result     $max_sum = PHP_INT_MIN ;      // Consider all blocks      // starting with i.     for ( $i = 0; $i < $n - $k + 1; $i++)     {         $current_sum = 0;         for ( $j = 0; $j < $k; $j++)             $current_sum = $current_sum +                              $arr[$i + $j];          // Update result if required.         $max_sum = max($current_sum, $max_sum );     }      return $max_sum; }      // Driver code     $arr = array(1, 4, 2, 10, 2, 3, 1, 0, 20);     $k = 4;     $n = count($arr);     echo maxSum($arr, $n, $k);  // This code is contributed by anuj_67. ?> 

Output
24

Time complexity: O(k*n) as it contains two nested loops.
Auxiliary Space: O(1)

Applying the sliding window technique: 

  • We compute the sum of the first k elements out of n terms using a linear loop and store the sum in variable window_sum.
  • Then we will traverse linearly over the array till it reaches the end and simultaneously keep track of the maximum sum.
  • To get the current sum of a block of k elements just subtract the first element from the previous block and add the last element of the current block.

The below representation will make it clear how the window slides over the array.

Consider an array arr[] = {5, 2, -1, 0, 3} and value of k = 3 and n = 5

This is the initial phase where we have calculated the initial window sum starting from index 0 . At this stage the window sum is 6. Now, we set the maximum_sum as current_window i.e 6. 
 

Now, we slide our window by a unit index. Therefore, now it discards 5 from the window and adds 0 to the window. Hence, we will get our new window sum by subtracting 5 and then adding 0 to it. So, our window sum now becomes 1. Now, we will compare this window sum with the maximum_sum. As it is smaller, we won’t change the maximum_sum. 
 


Similarly, now once again we slide our window by a unit index and obtain the new window sum to be 2. Again we check if this current window sum is greater than the maximum_sum till now. Once, again it is smaller so we don’t change the maximum_sum.
Therefore, for the above array our maximum_sum is 6.

Below is the code for above approach:

C++
// O(n) solution for finding maximum sum of // a subarray of size k #include <iostream> using namespace std;  // Returns maximum sum in a subarray of size k. int maxSum(int arr[], int n, int k) {     // n must be greater     if (n <= k) {         cout << "Invalid";         return -1;     }      // Compute sum of first window of size k     int max_sum = 0;     for (int i = 0; i < k; i++)         max_sum += arr[i];      // Compute sums of remaining windows by     // removing first element of previous     // window and adding last element of     // current window.     int window_sum = max_sum;     for (int i = k; i < n; i++) {         window_sum += arr[i] - arr[i - k];         max_sum = max(max_sum, window_sum);     }      return max_sum; }  // Driver code int main() {     int arr[] = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };     int k = 4;     int n = sizeof(arr) / sizeof(arr[0]);     cout << maxSum(arr, n, k);     return 0; } 
Java
// Java code for // O(n) solution for finding // maximum sum of a subarray // of size k class GFG {      // Returns maximum sum in     // a subarray of size k.     static int maxSum(int arr[], int n, int k)     {         // n must be greater         if (n <= k) {             System.out.println("Invalid");             return -1;         }          // Compute sum of first window of size k         int max_sum = 0;         for (int i = 0; i < k; i++)             max_sum += arr[i];          // Compute sums of remaining windows by         // removing first element of previous         // window and adding last element of         // current window.         int window_sum = max_sum;         for (int i = k; i < n; i++) {             window_sum += arr[i] - arr[i - k];             max_sum = Math.max(max_sum, window_sum);         }          return max_sum;     }      // Driver code     public static void main(String[] args)     {         int arr[] = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };         int k = 4;         int n = arr.length;         System.out.println(maxSum(arr, n, k));     } }  // This code is contributed // by  prerna saini. 
Python
# O(n) solution for finding # maximum sum of a subarray of size k   def maxSum(arr, k):     # length of the array     n = len(arr)      # n must be greater than k     if n <= k:         print("Invalid")         return -1      # Compute sum of first window of size k     window_sum = sum(arr[:k])      # first sum available     max_sum = window_sum      # Compute the sums of remaining windows by     # removing first element of previous     # window and adding last element of     # the current window.     for i in range(n - k):         window_sum = window_sum - arr[i] + arr[i + k]         max_sum = max(window_sum, max_sum)      return max_sum   # Driver code arr = [1, 4, 2, 10, 2, 3, 1, 0, 20] k = 4 print(maxSum(arr, k))  # This code is contributed by Kyle McClay 
C#
// C# code for O(n) solution for finding // maximum sum of a subarray of size k using System;  class GFG {      // Returns maximum sum in     // a subarray of size k.     static int maxSum(int[] arr, int n, int k)     {          // n must be greater         if (n <= k) {             Console.WriteLine("Invalid");             return -1;         }          // Compute sum of first window of size k         int max_sum = 0;         for (int i = 0; i < k; i++)             max_sum += arr[i];          // Compute sums of remaining windows by         // removing first element of previous         // window and adding last element of         // current window.         int window_sum = max_sum;         for (int i = k; i < n; i++) {             window_sum += arr[i] - arr[i - k];             max_sum = Math.Max(max_sum, window_sum);         }          return max_sum;     }      // Driver code     public static void Main()     {         int[] arr = { 1, 4, 2, 10, 2, 3, 1, 0, 20 };         int k = 4;         int n = arr.Length;         Console.WriteLine(maxSum(arr, n, k));     } }  // This code is contributed by anuj_67. 
JavaScript
<script>     // Javascript code for     // O(n) solution for finding     // maximum sum of a subarray     // of size k     function maxSum(arr, n, k) {         let max = 0;         let sum = 0;         // find initial sum of first k elements         for (let i = 0; i < k; i++) {             sum += arr[i];             max = sum;         }         // iterate the array once         // and increment the right edge         for (let i = k; i < n; i++) {             sum += arr[i] - arr[i - k];                          // compare if sum is more than max,             // if yes then replace             // max with new sum value             if (sum > max) {                 max = sum;             }         }         return max;     }  // Driver code let arr = [1, 4, 2, 10, 2, 3, 1, 0, 20]; let k = 4; let n = arr.length; document.write(maxSum(arr, n, k));  </script> 
PHP
<?php // O(n) solution for finding maximum sum of // a subarray of size k  // Returns maximum sum in a  // subarray of size k. function maxSum( $arr, $n, $k) {     // n must be greater     if ($n <= $k)     {         echo "Invalid";         return -1;     }      // Compute sum of first     // window of size k     $max_sum = 0;     for($i = 0; $i < $k; $i++)     $max_sum += $arr[$i];      // Compute sums of remaining windows by     // removing first element of previous     // window and adding last element of     // current window.     $window_sum = $max_sum;     for ($i = $k; $i < $n; $i++)     {         $window_sum += $arr[$i] - $arr[$i - $k];         $max_sum = max($max_sum, $window_sum);     }      return $max_sum; }      // Driver code     $arr = array(1, 4, 2, 10, 2, 3, 1, 0, 20);     $k = 4;     $n = count($arr);     echo maxSum($arr, $n, $k);  // This code is contributed by anuj_67 ?> 

Output
24

Time Complexity: O(n), where n is the size of input array arr[].
Auxiliary Space: O(1)

2. Smallest subarray with sum greater than a given value:

Given an array arr[] of integers and a number X, the task is to find the smallest subarray with a sum greater than the given value.

Approach:

We can solve this problem using Sliding Window Technique and maintaining two pointers: start and end to mark the starting and ending of the window. We can keep incrementing the end pointer till the sum of the window is less than or equal to X. When, the sum of window becomes greater than X, we record the length of the window and start moving the start pointer till the sum of window becomes smaller than or equal to X. Now, when the sum becomes smaller than or equal to X, again start incrementing the end pointer. Keep on moving the start and end pointer till we have reached the end of the array.

3. Find subarray with given sum in an array of non-negative integers:

Given an array arr[] of non-negative integers and an integer sum, find a subarray that adds to a given sum.

Approach:

The idea is simple as we know that all the elements in subarray are positive so, If a subarray has sum greater than the given sum then there is no possibility that adding elements to the current subarray will be equal to the given sum. So the Idea is to use a similar approach to a sliding window. 

  • Start with an empty subarray.
  • add elements to the subarray until the sum is less than x( given sum ). 
  • If the sum is greater than x, remove elements from the start of the current subarray.

4. Smallest window that contains all characters of string itself:

Approach:

Basically a window of characters is maintained by using two pointers namely start and end. These start and end pointers can be used to shrink and increase the size of window respectively. Whenever the window contains all characters of given string, the window is shrinked from left side to remove extra characters and then its length is compared with the smallest window found so far. 
If in the present window, no more characters can be deleted then we start increasing the size of the window using the end until all the distinct characters present in the string are also there in the window. Finally, find the minimum size of each window.

Practice Problems on Sliding Window Technique:

Problem

Problem Link

Find Subarray with given sum

Solve

Sliding Window Maximum (Maximum of all subarrays of size K)

Solve

Longest Sub-Array with Sum K

Solve

Find maximum (or minimum) sum of a subarray of size k

Solve

Smallest window in a String containing all characters of other String

Solve

Length of the longest substring without repeating characters

Solve

First negative integer in every window of size k

Solve

Count distinct elements in every window of size k

Solve

Smallest window that contains all characters of string itself

Solve

Largest sum subarray with at-least k numbers

Solve

Check if Permutation of Pattern is Substring

Solve

Related Articles:

  • Recent Articles on Sliding Window Technique
  • Practice Questions on Sliding Window
  • DSA Self-Paced – The Most used and Trusted Course on DSA


Next Article
Prefix Sum Array - Implementation and Applications

K

Kanika Thakral
Improve
Article Tags :
  • Algorithms
  • DSA
  • Technical Scripter
Practice Tags :
  • Algorithms

Similar Reads

  • DSA Tutorial - Learn Data Structures and Algorithms
    DSA (Data Structures and Algorithms) is the study of organizing data efficiently using data structures like arrays, stacks, and trees, paired with step-by-step procedures (or algorithms) to solve problems effectively. Data structures manage how data is stored and accessed, while algorithms focus on
    7 min read
  • Array Data Structure Guide
    In this article, we introduce array, implementation in different popular languages, its basic operations and commonly seen problems / interview questions. An array stores items (in case of C/C++ and Java Primitive Arrays) or their references (in case of Python, JS, Java Non-Primitive) at contiguous
    4 min read
  • String in Data Structure
    A string is a sequence of characters. The following facts make string an interesting data structure. Small set of elements. Unlike normal array, strings typically have smaller set of items. For example, lowercase English alphabet has only 26 characters. ASCII has only 256 characters.Strings are immu
    3 min read
  • Matrix Data Structure
    Matrix Data Structure is a two-dimensional array arranged in rows and columns. It is commonly used to represent mathematical matrices and is fundamental in various fields like mathematics, computer graphics, and data processing. Matrices allow for efficient storage and manipulation of data in a stru
    2 min read
  • Searching Algorithms
    Searching algorithms are essential tools in computer science used to locate specific items within a collection of data. In this tutorial, we are mainly going to focus upon searching in an array. When we search an item in an array, there are two most common algorithms used based on the type of input
    3 min read
  • Sorting Algorithms
    A Sorting Algorithm is used to rearrange a given array or list of elements in an order. For example, a given array [10, 20, 5, 2] becomes [2, 5, 10, 20] after sorting in increasing order and becomes [20, 10, 5, 2] after sorting in decreasing order. There exist different sorting algorithms for differ
    3 min read
  • Hashing in Data Structure
    Hashing is a technique used in data structures that efficiently stores and retrieves data in a way that allows for quick access. Hashing involves mapping data to a specific index in a hash table (an array of items) using a hash function. It enables fast retrieval of information based on its key. The
    3 min read
  • Two Pointers Technique
    Two pointers is really an easy and effective technique that is typically used for Two Sum in Sorted Arrays, Closest Two Sum, Three Sum, Four Sum, Trapping Rain Water and many other popular interview questions. Given a sorted array arr (sorted in ascending order) and a target, find if there exists an
    12 min read
  • Sliding Window Technique
    Sliding Window problems involve moving a fixed or variable-size window through a data structure, typically an array or string, to solve problems efficiently based on continuous subsets of elements. This technique is used when we need to find subarrays or substrings according to a given set of condit
    15+ min read
  • Prefix Sum Array - Implementation and Applications
    Given an array arr[] of size n, the task is to find the prefix sum of the array. A prefix sum array is another array prefixSum[] of the same size, such that prefixSum[i] is arr[0] + arr[1] + arr[2] . . . arr[i]. Examples: Input: arr[] = [10, 20, 10, 5, 15]Output: 10 30 40 45 60Explanation: For each
    8 min read
geeksforgeeks-footer-logo
Corporate & Communications Address:
A-143, 7th Floor, Sovereign Corporate Tower, Sector- 136, Noida, Uttar Pradesh (201305)
Registered Address:
K 061, Tower K, Gulshan Vivante Apartment, Sector 137, Noida, Gautam Buddh Nagar, Uttar Pradesh, 201305
GFG App on Play Store GFG App on App Store
Advertise with us
  • Company
  • About Us
  • Legal
  • Privacy Policy
  • In Media
  • Contact Us
  • Advertise with us
  • GFG Corporate Solution
  • Placement Training Program
  • Languages
  • Python
  • Java
  • C++
  • PHP
  • GoLang
  • SQL
  • R Language
  • Android Tutorial
  • Tutorials Archive
  • DSA
  • Data Structures
  • Algorithms
  • DSA for Beginners
  • Basic DSA Problems
  • DSA Roadmap
  • Top 100 DSA Interview Problems
  • DSA Roadmap by Sandeep Jain
  • All Cheat Sheets
  • Data Science & ML
  • Data Science With Python
  • Data Science For Beginner
  • Machine Learning
  • ML Maths
  • Data Visualisation
  • Pandas
  • NumPy
  • NLP
  • Deep Learning
  • Web Technologies
  • HTML
  • CSS
  • JavaScript
  • TypeScript
  • ReactJS
  • NextJS
  • Bootstrap
  • Web Design
  • Python Tutorial
  • Python Programming Examples
  • Python Projects
  • Python Tkinter
  • Python Web Scraping
  • OpenCV Tutorial
  • Python Interview Question
  • Django
  • Computer Science
  • Operating Systems
  • Computer Network
  • Database Management System
  • Software Engineering
  • Digital Logic Design
  • Engineering Maths
  • Software Development
  • Software Testing
  • DevOps
  • Git
  • Linux
  • AWS
  • Docker
  • Kubernetes
  • Azure
  • GCP
  • DevOps Roadmap
  • System Design
  • High Level Design
  • Low Level Design
  • UML Diagrams
  • Interview Guide
  • Design Patterns
  • OOAD
  • System Design Bootcamp
  • Interview Questions
  • Inteview Preparation
  • Competitive Programming
  • Top DS or Algo for CP
  • Company-Wise Recruitment Process
  • Company-Wise Preparation
  • Aptitude Preparation
  • Puzzles
  • School Subjects
  • Mathematics
  • Physics
  • Chemistry
  • Biology
  • Social Science
  • English Grammar
  • Commerce
  • World GK
  • GeeksforGeeks Videos
  • DSA
  • Python
  • Java
  • C++
  • Web Development
  • Data Science
  • CS Subjects
@GeeksforGeeks, Sanchhaya Education Private Limited, All rights reserved
We use cookies to ensure you have the best browsing experience on our website. By using our site, you acknowledge that you have read and understood our Cookie Policy & Privacy Policy
Lightbox
Improvement
Suggest Changes
Help us improve. Share your suggestions to enhance the article. Contribute your expertise and make a difference in the GeeksforGeeks portal.
geeksforgeeks-suggest-icon
Create Improvement
Enhance the article with your expertise. Contribute to the GeeksforGeeks community and help create better learning resources for all.
geeksforgeeks-improvement-icon
Suggest Changes
min 4 words, max Words Limit:1000

Thank You!

Your suggestions are valuable to us.

What kind of Experience do you want to share?

Interview Experiences
Admission Experiences
Career Journeys
Work Experiences
Campus Experiences
Competitive Exam Experiences